// 이분탐색
// 간만에 새로운 유형의 문제가 나왔다.
// 알고리즘을 생각해내기 쉽지 않은 유형의 문제이다.
// 이분 탐색이라는 것이
// 최소와 최대치의 중간을 계속해서 갱신해나가면서 푸는 문제 유형이다.
// 여기에선, 입국심사원이 주어진 시간동안 감당해낼 수 있는 사람의 수를
// 연산하면서 구하는 문제이다.
// 입국심사원은 입국심사를 병렬적으로 진행하는 방식이고
// 주어진 시간동안 자신이 최대로 몇명 처리할 수 있는지가 정해져 있다.
// 그렇다면, 그 뒤부터는 최적화 문제가 된다.
// 최적화 시에 더 빨리 처리하는 사람에겐 더 많은 심사가 이루어져야 한다.
// 이를 측정하는 방식이 ////// 부분이다.
// 단위 시간동안 n 명을 다 심사하거나, 더 많은 사람을 심사했을 때,
// 시간을 기록하여, 최소 시간인지를 계속 파악한다.
// 이분탐색에서 left 가 right 을 넘어가는 순간이 종료 순간이며
// 그 전까지는 계속해서, 주어진 시간에 얼마큼의 사람을 심사하는지를 체크한다.
// 알고리즘 방식이 특이함에 유의
// 단위 시간동안 더 사람을 처리할 수 있으면, 시간을 줄여보고
// 단위 시간동안 사람을 더 처리하면, 시간을 늘려보고
// 이 방식을 계속해서 사용한다.
// 그리고 mid 부분에서 +- 1 씩을 계속해줘야,
// 중복 부분이 없이 진행된다. left > right 가 넘는 부분을 만들기 위함임
// left = 1 은 상징적인 숫자이다.

function solution(n, times) {
  let left = 1;
  let right = n * Math.max(...times);
  let ans = Infinity;
  let mid;

  while (left <= right) {
    mid = parseInt((left + right) / 2);

    let cnt = 0;
    for (let time of times) cnt += parseInt(mid / time);

    if (cnt >= n) right = mid - 1;
    else left = mid + 1;

    if (n <= cnt) ans = Math.min(mid, ans); ///////
  }

  return ans;
}
